"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugRouteSwitch = exports.freezeRouteRefresh = void 0;
const React = require("react");
const react_router_1 = require("react-router");
const debugRouteCache = {
    active: 0,
    paths: [],
    refresh: undefined,
};
function freezeRouteRefresh() {
    debugRouteCache.active++;
    return () => {
        var _a;
        debugRouteCache.active--;
        if (!debugRouteCache.active) {
            (_a = debugRouteCache.refresh) === null || _a === void 0 ? void 0 : _a.call(debugRouteCache, (s) => s + 1);
        }
    };
}
exports.freezeRouteRefresh = freezeRouteRefresh;
const DebugRouteSwitch = ({ paths, NotFound }) => {
    const [_, triggerChange] = React.useState(0);
    React.useEffect(() => {
        debugRouteCache.refresh = triggerChange;
        return () => {
            debugRouteCache.refresh = undefined;
        };
    }, []);
    if (!debugRouteCache.active) {
        debugRouteCache.paths = paths;
    }
    return (React.createElement(react_router_1.Switch, null,
        debugRouteCache.paths.map(({ path, Component }) => (React.createElement(react_router_1.Route, { exact: true, key: path, path: path, component: Component }))),
        React.createElement(react_router_1.Route, { component: NotFound })));
};
exports.DebugRouteSwitch = DebugRouteSwitch;
//# sourceMappingURL=DebugRouteSwitch.js.map